 addHook("PlayerThink", function(player)
	if (player.mo.skin == "espio" or player.mo.skin == "mighty" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "heavy" or player.mo.skin == "bomb") and player.playerstate == PST_LIVE and not (player.powers[pw_carry])
		player.drawangle = player.mo.angle
		if (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and player.mo.skin != "heavy" and not (player.pflags & PF_SPINNING)
			player.mo.friction = FRACUNIT
		end
		if not (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and player.mo.skin != "heavy" and not (player.pflags & PF_SPINNING)
			player.mo.friction = 9*FRACUNIT/10
		end
		if player.speed > 72*FRACUNIT and not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.skin != "heavy" and not (player.pflags & PF_SPINNING)
			player.mo.friction = 9*FRACUNIT/10
		end
		if player.speed > 120*FRACUNIT and (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.skin != "heavy" and not (player.pflags & PF_SPINNING)
			player.mo.friction = 9*FRACUNIT/10
		end
		if player.mo.skin == "heavy"
			if player.mo.heavyvars.tics > 18 and not (player.pflags & PF_USEDOWN)
				player.mo.heavyvars.tics = 18
			end
			if player.mo.heavyvars.tics == 3 and player.pflags & PF_USEDOWN
				player.mo.heavyvars.tics = 18
			end
			if player.mo.heavyvars.tics
				player.mo.friction = FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, FixedMul(mo.scale, player.maxdash))
			end
			if not (player.mo.heavyvars.tics)
				player.mo.friction = 9*FRACUNIT/10
			end
			if player.mo.eflags & MFE_UNDERWATER and (player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo))
				player.mindash = 72*FRACUNIT
				player.maxdash = 72*FRACUNIT
			end
			if (not (player.mo.eflags & MFE_UNDERWATER)) or (player.mo.eflags & MFE_UNDERWATER and not (player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo)))
				player.mindash = 36*FRACUNIT
				player.maxdash = 36*FRACUNIT
			end
		end
		if (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH and player.mo.skin != "heavy"
			player.mindash = 60*FRACUNIT
			player.maxdash = 120*FRACUNIT
		end
		if not (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH and player.mo.skin != "heavy"
			player.mindash = 36*FRACUNIT
			player.maxdash = 72*FRACUNIT
		end
		if (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH and player.mo.skin != "heavy"
			player.mindash = 30*FRACUNIT
			player.maxdash = 120*FRACUNIT
		end
		if not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH and player.mo.skin != "heavy"
			player.mindash = 18*FRACUNIT
			player.maxdash = 72*FRACUNIT
		end
		if player.mo.skin == "espio" and player.pflags & PF_THOKKED and player.panim != PA_DASH
			player.pflags = $ | PF_SPINNING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_THOKKED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
		if player.mo.skin == "vector" and player.pflags & PF_THOKKED and player.mo.state == S_PLAY_JUMP
			player.mo.state = S_PLAY_FALL
			player.pflags = $ | PF_NOJUMPDAMAGE
		end
		if player.mo.skin != "heavy" and not (player.mo.eflags & MFE_UNDERWATER) and player.speed > 36*FRACUNIT
			player.actionspd = player.speed
		end
		if player.mo.skin != "heavy" and player.mo.eflags & MFE_UNDERWATER and player.speed > 36*FRACUNIT
			player.actionspd = player.speed*2
		end
		if player.mo.skin != "heavy" and not (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.speed <= 36*FRACUNIT
			player.actionspd = 36*FRACUNIT
		end
		if player.mo.skin != "heavy" and not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.speed <= 36*FRACUNIT
			player.actionspd = 72*FRACUNIT
		end
		if player.mo.skin != "heavy" and (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.speed <= 36*FRACUNIT
			player.actionspd = 60*FRACUNIT
		end
		if player.mo.skin != "heavy" and (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.speed <= 36*FRACUNIT
			player.actionspd = 120*FRACUNIT
		end
		if player.mo.skin != "heavy" and not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.actionspd > 72*FRACUNIT
			player.actionspd = 72*FRACUNIT
		end
		if player.mo.skin != "heavy" and (player.powers[pw_sneakers] or player.powers[pw_super]) and player.actionspd > 120*FRACUNIT
			player.actionspd = 120*FRACUNIT
		end
		if player.mo.state == S_MIGHTY_HAMMERDROP_SPRING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
		end
		if player.mo.skin == "mighty" and player.mo.mighty_hammerdrop_ghosttics and player.mo.eflags & MFE_JUSTHITFLOOR and player.mo.state == S_PLAY_ROLL
			player.pflags = $ | PF_STARTJUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
			player.mo.friction = FRACUNIT
			if player.pflags & PF_JUMPDOWN
				S_StartSound(player.mo, sfx_jump)
			end
			if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, (39*player.jumpfactor)/4, false)
			end
			if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 18*player.jumpfactor, false)
			end
			if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and player.mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (23*player.jumpfactor)/4, false)
			end
			if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and player.mo.eflags & MFE_UNDERWATER
				P_SetObjectMomZ(player.mo, (21*player.jumpfactor)/2, false)
			end
		end
		if not P_IsObjectOnGround(player.mo) and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_STUN or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP)) and not (player.pflags & PF_THOKKED) and not (player.pflags & PF_BOUNCING) and not (player.pflags & PF_SHIELDABILITY) and P_PlayerInPain(player) == false
			if player.mo.momz > 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.state = S_PLAY_SPRING
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
			if player.mo.momz <= 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.state = S_PLAY_FALL
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
			if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
				player.mo.state = S_PLAY_SPRING
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
			if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz >= 0
				player.mo.state = S_PLAY_FALL
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
		end
		if player.pflags & PF_SHIELDABILITY and player.mo.state != S_PLAY_JUMP and not (player.charflags & SF_NOSHIELDABILITY)
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ | PF_JUMPED
		end
	end
	if (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "amy" or player.mo.skin == "fang") and player.playerstate == PST_LIVE and not (player.powers[pw_carry])
		player.drawangle = player.mo.angle
		if player.mo.skin == "tails" and player.mo.state == S_PLAY_FLY
			player.powers[pw_tailsfly] = 999999
		end
		if player.powers[pw_tailsfly] and player.pflags & PF_JUMPDOWN
			player.fly1 = 1
		end
		if (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and not (player.pflags & PF_SPINNING)
			player.mo.friction = FRACUNIT
		end
		if not (player.cmd.forwardmove > 0 or player.cmd.forwardmove < 0 or player.cmd.sidemove > 0 or player.cmd.sidemove < 0) and not (player.pflags & PF_SPINNING)
			player.mo.friction = 9*FRACUNIT/10
		end
		if player.speed > 72*FRACUNIT and not (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.pflags & PF_SPINNING)
			player.mo.friction = 9*FRACUNIT/10
		end
		if player.speed > 120*FRACUNIT and (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.pflags & PF_SPINNING)
			player.mo.friction = 9*FRACUNIT/10
		end
		if player.mo.skin == "sonic" and not (player.mo.eflags & MFE_UNDERWATER)
			player.actionspd = player.speed
		end
		if player.mo.skin == "sonic" and player.mo.eflags & MFE_UNDERWATER
			player.actionspd = player.speed*2
		end
		if player.mo.skin == "sonic" and not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.actionspd > 72*FRACUNIT
			player.actionspd = 72*FRACUNIT
		end
		if player.mo.skin == "sonic" and (player.powers[pw_sneakers] or player.powers[pw_super]) and player.actionspd > 120*FRACUNIT
			player.actionspd = 120*FRACUNIT
		end
		if player.mo.skin == "knuckles" and not (player.mo.eflags & MFE_UNDERWATER)
			player.actionspd = 36*FRACUNIT
		end
		if player.mo.skin == "knuckles" and player.mo.eflags & MFE_UNDERWATER
			player.actionspd = 72*FRACUNIT
		end
		if player.mo.skin == "sonic" and player.pflags & PF_THOKKED and not (player.pflags & PF_SHIELDABILITY)
			player.pflags = $ | PF_SPINNING
			player.pflags = $ | PF_JUMPED
			player.pflags = $ | PF_THOKKED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
		if (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH
			player.mindash = 60*FRACUNIT
			player.maxdash = 120*FRACUNIT
		end
		if not (player.powers[pw_sneakers] or player.powers[pw_super]) and not (player.mo.eflags & MFE_UNDERWATER) and player.pflags & PF_STARTDASH
			player.mindash = 36*FRACUNIT
			player.maxdash = 72*FRACUNIT
		end
		if (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH
			player.mindash = 30*FRACUNIT
			player.maxdash = 120*FRACUNIT
		end
		if not (player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.eflags & MFE_UNDERWATER and player.pflags & PF_STARTDASH
			player.mindash = 18*FRACUNIT
			player.maxdash = 72*FRACUNIT
		end
		if not (P_IsObjectOnGround(player.mo)) and ((player.mo.skin == "tails" and player.mo.state == S_PLAY_FLY) or (player.mo.skin == "metalsonic" and player.pflags & PF_THOKKED and (player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH))) and (player.pflags & PF_USEDOWN and player.pflags & PF_JUMPDOWN)
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ | PF_JUMPED
			player.pflags = $ & ~PF_NOJUMPDAMAGE
			player.pflags = $ & ~PF_THOKKED
			player.secondjump = 0
		end
		if player.mo.skin == "amy" and not (player.pflags & PF_STARTDASH or player.pflags & PF_SPINNING)
			player.charability2 = CA2_MELEE
			player.mindash = 2*FRACUNIT
			player.maxdash = 0
		end
		if player.mo.state == S_PLAY_MELEE_LANDING
			player.mo.friction = FRACUNIT
			if player.speed > 0 then
				player.mo.state = S_PLAY_WALK
			end
			if player.speed == 0 then
				player.mo.state = S_PLAY_STND
			end
			if player.pflags & PF_USEDOWN and not (player.pflags & PF_JUMPDOWN) and player.speed >= 5*FRACUNIT
				player.mo.state = S_PLAY_ROLL
				player.pflags = $ | PF_SPINNING
				S_StartSound(player.mo, sfx_spin)
			end
			if player.pflags & PF_USEDOWN and not (player.pflags & PF_JUMPDOWN) and player.speed < 5*FRACUNIT
				player.charability2 = CA2_SPINDASH
				player.mo.state = S_PLAY_SPINDASH
				player.pflags = $ | PF_SPINNING
				player.pflags = $ | PF_STARTDASH
				S_StartSound(player.mo, sfx_spndsh)
			end
			if (player.pflags & PF_JUMPDOWN and not (player.pflags & PF_USEDOWN)) or (player.pflags & PF_STARTJUMP and player.pflags & PF_SPINNING)
				player.mo.state = S_PLAY_ROLL
				player.pflags = $ | PF_STARTJUMP
				player.pflags = $ | PF_JUMPED
				player.pflags = $ & ~PF_NOJUMPDAMAGE
				S_StartSound(player.mo, sfx_jump)
				if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, (39*player.jumpfactor)/4, false)
				end
				if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and not (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, 18*player.jumpfactor, false)
				end
				if not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and player.mo.eflags & MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (23*player.jumpfactor)/4, false)
				end
				if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS and player.mo.eflags & MFE_UNDERWATER
					P_SetObjectMomZ(player.mo, (21*player.jumpfactor)/2, false)
				end
			end
		end
		if not P_IsObjectOnGround(player.mo) and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_PAIN or player.mo.state == S_PLAY_STUN or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP)) and (not (player.pflags & PF_THOKKED) or (player.mo.skin == "amy" and player.pflags & PF_THOKKED)) and not (player.pflags & PF_BOUNCING) and not (player.glidelast) and not (player.bouncelast) and not (player.pflags & PF_SHIELDABILITY) and P_PlayerInPain(player) == false
			if player.mo.momz > 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.state = S_PLAY_SPRING
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
			if player.mo.momz <= 0 and not (player.mo.eflags & MFE_VERTICALFLIP)
				player.mo.state = S_PLAY_FALL
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
			if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
				player.mo.state = S_PLAY_SPRING
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
			if player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz >= 0
				player.mo.state = S_PLAY_FALL
				player.pflags = $ | PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
			end
		end
		if player.pflags & PF_SHIELDABILITY and player.mo.state != S_PLAY_JUMP
			player.mo.state = S_PLAY_JUMP
			player.pflags = $ | PF_JUMPED
		end
	--Glide & Bounce Momentum Code by Frostiikin
		if player.mo.skin == "knuckles"
			if player.glidelast == nil
				player.glidelast = 0
			end
			local gliding = player.pflags & PF_GLIDING
			local thokked = player.pflags & PF_THOKKED
			local exitglide = (player.glidelast == 1 and not (gliding) and thokked)
			local landglide = (player.glidelast == 2 and not (gliding|thokked))
			if exitglide or landglide
				player.mo.momx = player.lastmomx
				player.mo.momy = player.lastmomy
			end
			if exitglide and player.mo.state != S_PLAY_JUMP
				player.mo.state = S_PLAY_JUMP
				player.pflags = $ | PF_JUMPED
				player.pflags = $ & ~PF_NOJUMPDAMAGE
				player.pflags = $ & ~PF_THOKKED
				player.pflags = $ & ~PF_GLIDING
			end
			if gliding
				player.glidelast = 1
			elseif exitglide
				player.glidelast = 2
			elseif not(gliding|thokked)
				player.glidelast = 0
			end
		end
		if player.mo.skin == "fang"
			if player.bouncelast == nil
				player.bouncelast = false
			end
			if player.pflags & PF_BOUNCING and not (player.bouncelast) and player.mo.state != S_PLAY_PAIN and player.mo.state != S_PLAY_STUN
			or (not (player.pflags & PF_BOUNCING) and player.bouncelast) and player.mo.state != S_PLAY_PAIN and player.mo.state != S_PLAY_STUN
				player.mo.momx = player.lastmomx
				player.mo.momy = player.lastmomy
				if (not (player.pflags & PF_BOUNCING) and player.bouncelast)
					player.mo.state = S_PLAY_JUMP
					player.pflags = $ | PF_JUMPED
					player.pflags = $ | PF_NOJUMPDAMAGE
					player.pflags = $ & ~PF_THOKKED
					player.pflags = $ & ~PF_BOUNCING
				end
			end
			player.bouncelast = (player.pflags & PF_BOUNCING > 0)
		end
		player.lastmomx = player.mo.momx
		player.lastmomy = player.mo.momy
	end
end)
-- Repurposed Spam Dash Code by Starlight
local function Uncurl(player)
	if (player.mo.skin != "charmy" and player.mo.skin != "vector" and player.mo.skin != "bomb") and player.playerstate == PST_LIVE and not (player.powers[pw_carry])
		if (player.speed > 5*FRACUNIT and player.pflags & PF_STARTDASH) then return true end
		if P_IsObjectOnGround(player.mo) and player.pflags & PF_SPINNING and not (player.pflags & (PF_USEDOWN|PF_STARTDASH)) then
			player.mo.state = S_PLAY_WALK
			player.pflags = ($ & ~PF_SPINNING) | PF_USEDOWN
			return true
		end
	end
end
addHook("SpinSpecial", Uncurl)
addHook("MobjDamage", function(enemy, mo, source)
	if (mo and mo.valid and (mo.state == S_PLAY_JUMP or mo.state == S_PLAY_ROLL))
		if (enemy and enemy.valid) and (mo.player.pflags & PF_THOKKED)
			mo.player.pflags = $ & ~PF_THOKKED
		end
	end
end)
addHook("MobjDeath", function(enemy, mo, source)
	if (mo and mo.valid and (mo.state == S_PLAY_JUMP or mo.state == S_PLAY_ROLL))
		if (enemy and enemy.valid) and (mo.player.pflags & PF_THOKKED)
			mo.player.pflags = $ & ~PF_THOKKED
		end
	end
end)
--Repurposed Egg Reverie Flight Code by Fyrid19
addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo.skin != "metalsonic" then return end
		if player.flying and player.cmd.buttons & BT_USE and player.cmd.buttons & BT_JUMP and (player.secondjump == 1 or player.secondjump == 2)
			player.flying = false
			player.secondjump = 0
		elseif not player.flying and not P_IsObjectOnGround(player.mo) and player.pflags & PF_THOKKED
			player.flying = true
		end
		if player.flying == nil
			player.flying = false
		end
		if P_IsObjectOnGround(player.mo)
			player.flying = false
		end
		if player.flying and (player.secondjump == 1 or player.secondjump == 2)
			if (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_USE)
				if player.mo.momz < 9*FRACUNIT/2
					player.mo.momz = $ + 2*FRACUNIT
				elseif player.mo.momz >= 9*FRACUNIT/2
					player.mo.momz = 9*FRACUNIT/2
				elseif player.mo.momz < 0
					player.mo.momz = 0
				end
			elseif (player.cmd.buttons & BT_USE) and not (player.cmd.buttons & BT_JUMP)
				if player.mo.momz > -9*FRACUNIT/2
					player.mo.momz = $ - 1*FRACUNIT
				elseif player.mo.momz <= -9*FRACUNIT/2
					player.mo.momz = -9*FRACUNIT/2
				elseif player.mo.momz > 0
					player.mo.momz = 0
				end
			elseif not ((player.cmd.buttons & BT_USE) or (player.cmd.buttons & BT_JUMP))
				player.mo.momz = 0
			end
			if player.dashmode < 3*TICRATE
				player.pflags = $ | PF_NOJUMPDAMAGE
			end
			if player.dashmode >= 3*TICRATE
				player.pflags = $ & ~PF_NOJUMPDAMAGE
			end
			if player.speed < player.runspeed
				player.mo.state = S_PLAY_FLOAT
			end
			if player.speed >= player.runspeed and (player.dashmode < 3*TICRATE or player.mo.skin != "metalsonic")
				player.mo.state = S_PLAY_FLOAT_RUN
			end
			if player.speed >= player.runspeed and player.dashmode >= 3*TICRATE and player.mo.skin == "metalsonic"
				player.mo.state = S_PLAY_DASH
			end
			player.pflags = $|PF_JUMPED|PF_THOKKED
		end
	end
end)